SystemOrganization addCategory: #homeWork!
SystemOrganization addCategory: #'homeWork-tests'!
SystemOrganization addCategory: #'homeWork-version1'!

Object subclass: #HWRoassalDrawer
	instanceVariableNames: 'elements selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWRoassalDrawer commentStamp: 'test 12/21/2018 16:05' prior: 0!
Responsible for drawing a Roassal view in the HWMainPresenter

It knows the list of elements that the HWMainPresenter is showing, and the element in this list that is selected.
It is responsible to show this element in some way!

HWRoassalDrawer subclass: #HWDrawerMethodsImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerMethodsImplementors commentStamp: 'allerschema 12/27/2018 14:28' prior: 0!
I am in charge of drawing a selector implemetors!

!HWDrawerMethodsImplementors methodsFor: 'drawing' stamp: 'allezschema 12/25/2018 00:49'!
drawOnRoassalView: aView
	| shape |
	shape := RTBox new
		size: 50;
		color: Color yellow trans.
	elements := shape elementsOn: selected senders.
	aView addAll: elements.
	elements @ RTPopup.
	RTFlowLayout on: elements! !

HWRoassalDrawer subclass: #HWDrawerSubclassesWithForceLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerSubclassesWithForceLayout methodsFor: 'drawing' stamp: 'test 12/21/2018 16:10'!
drawOnRoassalView: roassalView
	| es |
	roassalView @ RTDraggableView.
	es := (RTEllipse new
		size: 15;
		color: [ :c | 
			c = selected
				ifTrue: [ Color green ]
				ifFalse: [ Color black alpha: 0.5 ] ]) elementsOn: selected withAllSubclasses.
	roassalView addAll: es.
	es @ RTDraggable @ RTPopup.
	RTEdgeBuilder new
		view: roassalView;
		elements: es;
		connectFrom: #superclass.
	RTForceBasedLayout new on: es! !

HWRoassalDrawer subclass: #HWDrawerSuperclassesWithTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerSuperclassesWithTreeLayout methodsFor: 'drawing' stamp: 'test 12/21/2018 16:18'!
drawOnRoassalView: roassalView
	| es |
	roassalView @ RTDraggableView.
	es := (RTEllipse new
		size: 15;
		color: [ :c | 
			c = selected
				ifTrue: [ Color green ]
				ifFalse: [ Color black alpha: 0.5 ] ]) elementsOn: selected withAllSuperclasses.
	roassalView addAll: es.
	es @ RTDraggable @ RTPopup.
	RTEdgeBuilder new
		view: roassalView;
		elements: es;
		connectFrom: #superclass.
	RTTreeLayout new on: es! !

!HWRoassalDrawer methodsFor: 'drawing' stamp: 'test 12/21/2018 16:08'!
drawOnRoassalView: aView
	self subclassResponsibility! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
elements
	^ elements! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
elements: anObject
	elements := anObject! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
selected
	^ selected! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
selected: anObject
	selected := anObject! !

TestCase subclass: #WidgetClassListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-tests'!

!WidgetClassListTest methodsFor: 'as yet unclassified' stamp: 'allerSchema 12/19/2018 16:00'!
testFilter
	"Je permet de test filtre d'une liste "

	self assert: ((WidgetClassList new filter: OrderedCollection allSubclasses with: 'GL') at: 1) equals: GLMMultiValue! !

ComposablePresenter subclass: #HWMainPresenter
	instanceVariableNames: 'classes diagram roassalDrawer menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWMainPresenter commentStamp: 'test 12/21/2018 16:26' prior: 0!
REsponsible for opening a window with a list of elements on the left and a Roassal diagram on the right.
Selecting an elements in the list on the left will trigger a refresh of the roassal view on the right

[[[
			(HWMainPresenter withDrawer: HWDrawerSubclassesWithForceLayout) openWithSpec 
]]]!

!HWMainPresenter class methodsFor: 'specs' stamp: 'allezschema 12/23/2018 03:48'!
defaultSpec
	^ SpecLayout composed
		newRow: [ :r | 
			r
				newColumn: [ :c | 
					c add: #menu height: self toolbarHeight.
					c newRow: [ :row | row add: #classes ] ];
				newColumn: [ :c | c add: #diagram ] ]
			
		yourself! !

!HWMainPresenter class methodsFor: 'as yet unclassified' stamp: 'allezschema 12/25/2018 00:17'!
runMe
	<script>
	(HWMainPresenter
		withDrawer: HWDrawerMethodsImplementors
		elements: Object allSelectors) openWithSpec! !

!HWMainPresenter class methodsFor: 'as yet unclassified' stamp: 'test 12/21/2018 16:27'!
withDrawer: aDrawerClass
	^self basicNew
		withDrawer: aDrawerClass new;
		initialize ;
		yourself! !

!HWMainPresenter class methodsFor: 'as yet unclassified' stamp: 'allerschema 12/27/2018 16:07'!
withDrawer: aDrawerClass elements: aCollection
	^ self basicNew 
		withDrawer: aDrawerClass new;
		initialize;
		listClass:aCollection;
		yourself! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 15:05'!
classes
	^ classes! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 15:05'!
diagram
	^ diagram! !

!HWMainPresenter methodsFor: 'api' stamp: 'allezschema 12/23/2018 03:32'!
extent
	^ 900 @ 900! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allezschema 12/23/2018 03:30'!
initializePresenter
	self classes
		onClassSelected: [ :item |
			item=nil ifFalse: [  
			diagram refresh.
			roassalDrawer selected: item  ]]! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 12/28/2018 09:46'!
initializeWidgets
	classes := self instantiate: WidgetClassList.
	menu := self mainMenu.
	menu applyTo: self.
	self listClass: #().
	diagram := self instantiate: RoassalModel.
	self listClass
		menu: [ :aMenu | 
			MenuPresenter new
				addGroup: [ :group | 
					group
						addItem: [ :item | 
							item
								name: 'Browse';
								enabled: [ self listClass selectedItem notNil & self classes listClass selectedItem isSelectorSymbol ];
								action: [ self classes selectedClass: self classes listClass selectedItem.
									self withDrawer: HWDrawerMethodsImplementors new ] ] ];
				buildWithSpecAsPopup ].
	diagram script: [ :view :canvas | roassalDrawer drawOnRoassalView: view ]! !

!HWMainPresenter methodsFor: 'api' stamp: 'allerschema 12/28/2018 09:45'!
listClass
	^self classes listClass! !

!HWMainPresenter methodsFor: 'api' stamp: 'allezschema 12/22/2018 15:17'!
listClass: aCollection
self classes listClass: aCollection  ! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allezschema 12/23/2018 03:38'!
mainMenu
	| aMenu |
	aMenu := MenuPresenter new
		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: 'File';
						icon: (self iconNamed: #openIcon)].
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Open file';
						icon: (self iconNamed: #openIcon);
						action: [ self inform: 'Open File' ] ].
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Save File';
						icon: (self iconNamed: #smallSaveIcon);
						action: [ self inform: 'Save File' ] ].
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Print file';
						icon: (self iconNamed: #smallPrintIcon);
						action: [ self inform: 'Print file' ] ] ];
		addGroup: [ :group | 
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Undo';
						icon: (self iconNamed: #smallUndoIcon);
						action: [ self inform: 'Undo' ] ].
			group
				addItem: [ :item | 
					item
						name: nil;
						description: 'Redo';
						icon: (self iconNamed: #smallRedoIcon);
						action: [ self inform: 'Redo' ] ] ].
	^ aMenu! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allezschema 12/23/2018 03:42'!
menu
	^ menu! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allezschema 12/23/2018 03:42'!
menu: anObject
	menu := anObject! !

!HWMainPresenter methodsFor: 'as yet unclassified' stamp: 'allezschema 12/23/2018 03:29'!
title 
^'Visualization'.! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 16:25'!
withDrawer: aDrawerInstance
	roassalDrawer := aDrawerInstance ! !

ComposablePresenter subclass: #WidgetClassList
	instanceVariableNames: 'listClass filtre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!WidgetClassList commentStamp: 'allezschema 12/22/2018 15:55' prior: 0!
I contain the list of elements and the filter!

!WidgetClassList class methodsFor: 'overrides' stamp: 'allezschema 12/22/2018 16:00'!
defaultSpec
	| filtreHeight |
	filtreHeight := StandardFonts defaultFont height + 15.
	^ SpecLayout composed
		add: #listClass origin: 0 @ 0.05 corner: 1 @ 1;
		add: #filtre
			origin: 0 @ 0
			corner: 1 @ 0
			offsetOrigin: 0 @ 0
			offsetCorner: 0 @ filtreHeight;
		yourself! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 15:52'!
filter: aCollection with: aText

	^aCollection
		select: [ :cl | 
			(cl name matchesRegex: aText , '.*')
				 ].
	! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 12:25'!
filtre
	^ filtre! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:53'!
initializePresenter
	filtre
		whenTextChanged: [ :text | 
			text = ''
				ifFalse: [ listClass items: (self filter: self listClass listItems with: text , '.*') ]
				ifTrue: [ listClass items: (Object allSubclasses sort:[:a :b|a name<b name])] ]! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerschema 12/27/2018 15:57'!
initializeWidgets
	listClass := self newList.
	filtre := self newTextInput.
	"listClass items: (Object allSubclasses sort: [ :a :b | a name < b name ])."
	filtre
		ghostText: 'Enter a class name';
		autoAccept: true;
		removeEntryCompletion.
	self focusOrder
		add: listClass;
		add: filtre! !

!WidgetClassList methodsFor: 'api' stamp: 'allerSchema 12/19/2018 11:17'!
listClass
^listClass.! !

!WidgetClassList methodsFor: 'api' stamp: 'allezschema 12/20/2018 22:21'!
listClass: aCollection
	listClass items: aCollection .! !

!WidgetClassList methodsFor: 'api' stamp: 'allerSchema 12/20/2018 15:32'!
onClassSelected: aBlock
	self listClass whenSelectedItemChanged: aBlock! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:54'!
title
^'Listes des classes'! !
